import _isEqual from "lodash/isEqual";
import _get from "lodash/get";
import _forEach from "lodash/forEach";
var _excluded = ["values", "setValueOptions", "onChange"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import useArea from "@nickeylin/taroify-hooks/use-area";
import * as React from "react";
import { useContext, useEffect, useRef } from "react";
import Picker, { PickerContext } from "../picker";
import { useToRef } from "../utils/state";
import AreaPickerContext from "./area-picker.context";

function AreaPickerColumns(props) {
  var {
    children: data
  } = props;
  var {
    depth,
    formatter
  } = useContext(AreaPickerContext);

  var _useContext = useContext(PickerContext),
      {
    values: unverifiedValues,
    setValueOptions,
    onChange
  } = _useContext,
      restCtx = _objectWithoutProperties(_useContext, _excluded);

  var {
    columns,
    values,
    valueOptions,
    setValues,
    getValueOptions
  } = useArea(unverifiedValues, {
    data,
    depth,
    formatter
  });
  var onChangeRef = useToRef(onChange);
  var valuesRef = useRef();
  var columnRef = useRef();

  _forEach(valueOptions, (value, index) => setValueOptions === null || setValueOptions === void 0 ? void 0 : setValueOptions(value, {
    index
  }));

  useEffect(() => {
    if (columnRef.current && !_isEqual(valuesRef.current, values)) {
      var _onChangeRef$current;

      var option = _get(getValueOptions(), columnRef.current.index);

      (_onChangeRef$current = onChangeRef.current) === null || _onChangeRef$current === void 0 ? void 0 : _onChangeRef$current.call(onChangeRef, values, option, columnRef.current);
      valuesRef.current = values;
    }

    columnRef.current = undefined;
  }, [getValueOptions, onChangeRef, values]);
  return /*#__PURE__*/React.createElement(PickerContext.Provider, {
    value: _objectSpread({
      values,

      onChange(values, option, column) {
        columnRef.current = column;
        setValues(values);
      }

    }, restCtx)
  }, /*#__PURE__*/React.createElement(Picker.Columns, {
    children: columns
  }));
}

export default AreaPickerColumns;
//# sourceMappingURL=area-picker-columns.js.map
