import _size from "lodash/size";
import _get from "lodash/get";
var _excluded = ["style", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { Children, cloneElement, isValidElement, useMemo } from "react";
import { prefixClassname } from "../styles";
import { isElementOf } from "../utils/validate";
import Avatar from "./avatar";

var useAvatars = (children, shape, limit) => {
  return useMemo(() => {
    var avatars = Children.toArray(children).filter(child => /*#__PURE__*/isValidElement(child) && isElementOf(child, Avatar));

    var avatarsSize = _size(avatars);

    var luckyAvatars = [];
    var length = Math.min(avatarsSize, limit);

    for (var index = 0; index < length; index++) {
      var child = _get(avatars, index);

      var element = child;
      var {
        key,
        props
      } = element;

      var {
        style,
        children: _children
      } = props,
          restProps = _objectWithoutProperties(props, _excluded);

      luckyAvatars.push( /*#__PURE__*/cloneElement(element, _objectSpread({
        key: key !== null && key !== void 0 ? key : index,
        shape,
        style: _objectSpread(_objectSpread({}, style), {}, {
          zIndex: index
        })
      }, restProps), _children));
    }

    return [luckyAvatars, avatarsSize];
  }, [children, limit, shape]);
};

export default function AvatarGroup(props) {
  var {
    className,
    shape = "circle",
    limit = Number.MAX_VALUE,
    spacing = "small",
    total,
    children
  } = props;
  var [avatars, avatarsSize] = useAvatars(children, shape, limit);
  return /*#__PURE__*/React.createElement(View, {
    className: classNames(prefixClassname("avatar-group"), {
      [prefixClassname("avatar-group--spacing-mini")]: spacing === "mini",
      [prefixClassname("avatar-group--spacing-small")]: spacing === "small",
      [prefixClassname("avatar-group--spacing-medium")]: spacing === "medium",
      [prefixClassname("avatar-group--spacing-large")]: spacing === "large"
    }, className)
  }, avatars, avatarsSize >= limit && /*#__PURE__*/React.createElement(Avatar, {
    shape: shape,
    style: {
      zIndex: avatarsSize
    }
  }, "+", total ? total - limit : avatarsSize - limit));
}
//# sourceMappingURL=avatar-group.js.map
