import _toString from "lodash/toString";
import _isNumber from "lodash/isNumber";
import _gt from "lodash/gt";
var _excluded = ["className", "content", "max", "dot", "fixed", "position", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { useContext, useMemo } from "react";
import { prefixClassname } from "../styles";
import BadgeWrapper from "./badge-wrapper";
import BadgeWrapperContext from "./badge-wrapper.context";

function Badge(props) {
  var {
    className,
    content: contentProp,
    max,
    dot,
    fixed: fixedProp,
    position = "top-right",
    children
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var inWrapper = useContext(BadgeWrapperContext);
  var hasChildren = children !== undefined;
  var noChildren = children === undefined;
  var fixed = fixedProp !== null && fixedProp !== void 0 ? fixedProp : !!inWrapper;
  var content = useMemo(() => _isNumber(contentProp) ? _toString(_gt(contentProp, max) ? "".concat(max, "+") : contentProp) : contentProp, [contentProp, max]);
  var badge = /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("badge__badge"), {
      [prefixClassname("badge--dot")]: dot,
      [prefixClassname("badge--content")]: content,
      [prefixClassname("badge--fixed")]: fixed || hasChildren,
      [prefixClassname("badge--top-left")]: position === "top-left",
      [prefixClassname("badge--top-right")]: position === "top-right",
      [prefixClassname("badge--bottom-left")]: position === "bottom-left",
      [prefixClassname("badge--bottom-right")]: position === "bottom-right"
    }, className),
    children: !dot && content
  }, restProps));

  if (noChildren) {
    return badge;
  }

  return /*#__PURE__*/React.createElement(BadgeWrapper, null, children, (dot || content) && badge);
}

export default Badge;
//# sourceMappingURL=badge.js.map
