import _isString from "lodash/isString";
import _isNumber from "lodash/isNumber";
import _isBoolean from "lodash/isBoolean";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import * as React from "react";
import { cloneElement } from "react";
import { isElementOf } from "../utils/validate";
import Badge from "./badge";
export default function createBadge(badge) {
  var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  if (_isBoolean(badge) && badge) {
    return badgeProps => /*#__PURE__*/React.createElement(Badge, _objectSpread(_objectSpread({}, props), {}, {
      dot: true
    }, badgeProps));
  }

  if (_isNumber(badge) || _isString(badge)) {
    return badgeProps => /*#__PURE__*/React.createElement(Badge, _objectSpread(_objectSpread({}, props), {}, {
      content: badge
    }, badgeProps));
  }

  if (isElementOf(badge, Badge)) {
    return badgeProps => /*#__PURE__*/cloneElement(badge, _objectSpread(_objectSpread({}, props), badgeProps));
  }

  return badgeProps => /*#__PURE__*/React.createElement(Badge, _objectSpread(_objectSpread({}, props), badgeProps));
}
//# sourceMappingURL=create-badge.js.map
