var _excluded = ["className", "type", "children", "onClick"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import classNames from "classnames";
import * as React from "react";
import { useContext, useMemo } from "react";
import Button from "../button";
import { prefixClassname } from "../styles";
import CalendarContext from "./calendar.context";

function CalendarButton(props) {
  var {
    className,
    type = "confirm",
    children = "确定",
    onClick: _onClick
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var confirm = type === "confirm";
  var {
    value: currentValue,
    type: ctxType,
    onConfirm
  } = useContext(CalendarContext);
  var disabled = useMemo(() => {
    if (currentValue) {
      if (ctxType === "range") {
        return !currentValue[0] || !currentValue[1];
      }

      if (ctxType === "multiple") {
        return !currentValue.length;
      }
    }

    return !currentValue;
  }, [ctxType, currentValue]);
  return /*#__PURE__*/React.createElement(Button, _objectSpread({
    className: classNames({
      [prefixClassname("calendar__confirm")]: confirm
    }, className),
    shape: "round",
    block: true,
    disabled: confirm && disabled,
    color: "danger",
    children: children,
    onClick: event => {
      _onClick === null || _onClick === void 0 ? void 0 : _onClick(event);

      if (confirm && !disabled) {
        onConfirm === null || onConfirm === void 0 ? void 0 : onConfirm();
      }
    }
  }, restProps));
}

CalendarButton.defaultProps = {
  type: "confirm"
};
export default CalendarButton;
//# sourceMappingURL=calendar-button.js.map
