var _excluded = ["className", "style", "type", "value", "top", "bottom", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { useCallback, useContext } from "react";
import { prefixClassname } from "../styles";
import CalendarContext from "./calendar.context";

function CalendarDay(props) {
  var {
    className,
    style,
    type,
    value,
    top,
    bottom,
    children
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    type: ctxType,
    onDayClick
  } = useContext(CalendarContext);
  var single = ctxType === "single";
  var disabled = type === "disabled";
  var onClick = useCallback(() => {
    if (!disabled) {
      onDayClick === null || onDayClick === void 0 ? void 0 : onDayClick({
        type,
        value,
        children
      });
    }
  }, [children, disabled, onDayClick, type, value]);

  var renderContent = () => {
    if (single && type === "active") {
      return /*#__PURE__*/React.createElement(React.Fragment, null, top && /*#__PURE__*/React.createElement(View, {
        className: prefixClassname("calendar__day__top"),
        children: top
      }), /*#__PURE__*/React.createElement(View, {
        className: prefixClassname("calendar__active-day"),
        children: children
      }), bottom && /*#__PURE__*/React.createElement(View, {
        className: prefixClassname("calendar__day__bottom"),
        children: bottom
      }));
    }

    return /*#__PURE__*/React.createElement(React.Fragment, null, top && /*#__PURE__*/React.createElement(View, {
      className: prefixClassname("calendar__day__top"),
      children: top
    }), children, bottom && /*#__PURE__*/React.createElement(View, {
      className: prefixClassname("calendar__day__bottom"),
      children: bottom
    }));
  };

  return /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("calendar__day"), {
      [prefixClassname("calendar__day--".concat(type))]: type
    }, className),
    style: style,
    onClick: onClick
  }, restProps), renderContent());
}

export default CalendarDay;
//# sourceMappingURL=calendar-day.js.map
