import _map from "lodash/map";
import { View } from "@tarojs/components";
import * as React from "react";
import { useContext } from "react";
import { prefixClassname } from "../styles";
import CalendarContext from "./calendar.context";

function CalendarWeekdays(props) {
  var {
    firstDayOfWeek
  } = useContext(CalendarContext);
  var weekdays = ["日", "一", "二", "三", "四", "五", "六"];
  var renderWeekdays = [...weekdays.slice(firstDayOfWeek, 7), ...weekdays.slice(0, firstDayOfWeek)];
  return /*#__PURE__*/React.createElement(View, {
    className: prefixClassname("calendar__weekdays")
  }, _map(renderWeekdays, day => /*#__PURE__*/React.createElement(View, {
    className: prefixClassname("calendar__weekday"),
    key: day,
    children: day
  })));
}

export default CalendarWeekdays;
//# sourceMappingURL=calendar-weekdays.js.map
