import { ViewProps } from "@tarojs/components/types/View";
import { ReactNode } from "react";
import { CalendarDayObject, CalendarType, CalendarValueType } from "./calendar.shared";
declare type CalendarSubtitleRender = (date: Date) => ReactNode;
export interface CalendarProps extends ViewProps {
    type?: CalendarType;
    title?: ReactNode;
    subtitle?: ReactNode | CalendarSubtitleRender;
    defaultValue?: CalendarValueType;
    value?: CalendarValueType;
    min?: Date;
    max?: Date;
    firstDayOfWeek?: number;
    watermark?: boolean;
    readonly?: boolean;
    children?: ReactNode;
    formatter?(day: CalendarDayObject): CalendarDayObject;
    onChange?(value: any): void;
    onConfirm?(value: any): void;
}
declare function Calendar(props: CalendarProps): JSX.Element;
export default Calendar;
