import { ReactNode } from "react";
export { getEndDayOfMonth } from "../datetime-picker/datetime-picker.shared";
export declare type CalendarType = "single" | "multiple" | "range";
export declare type CalendarValueType = Date | Date[];
export declare type CalendarDayType = "" | "start" | "start-end" | "middle" | "end" | "selected" | "active" | "disabled" | "placeholder";
export interface CalendarDayObject {
    className?: string;
    type: CalendarDayType;
    value: Date;
    children: ReactNode;
    top?: ReactNode;
    bottom?: ReactNode;
}
export declare function compareYearMonth(date1: Date, date2: Date): 0 | 1 | -1;
export declare function compareDate(day1: Date, day2: Date): 0 | 1 | -1;
export declare const cloneDate: (date: Date) => Date;
export declare function createDayByOffset(date: Date, offset: number): Date;
export declare const createPreviousDay: (date: Date) => Date;
export declare const createNextDay: (date: Date) => Date;
export declare function createToday(): Date;
export declare const MIN_DATE: Date;
export declare const MAX_DATE: Date;
