export { getEndDayOfMonth } from "../datetime-picker/datetime-picker.shared";
export function compareYearMonth(date1, date2) {
  var year1 = date1 === null || date1 === void 0 ? void 0 : date1.getFullYear();
  var year2 = date2 === null || date2 === void 0 ? void 0 : date2.getFullYear();

  if (year1 === year2) {
    var month1 = date1 === null || date1 === void 0 ? void 0 : date1.getMonth();
    var month2 = date2 === null || date2 === void 0 ? void 0 : date2.getMonth();
    return month1 === month2 ? 0 : month1 > month2 ? 1 : -1;
  }

  return year1 > year2 ? 1 : -1;
}
export function compareDate(day1, day2) {
  var compareMonthResult = compareYearMonth(day1, day2);

  if (compareMonthResult === 0) {
    var date1 = day1 === null || day1 === void 0 ? void 0 : day1.getDate();
    var date2 = day2 === null || day2 === void 0 ? void 0 : day2.getDate();
    return date1 === date2 ? 0 : date1 > date2 ? 1 : -1;
  }

  return compareMonthResult;
}
export var cloneDate = date => new Date(date);
export function createDayByOffset(date, offset) {
  var cloned = cloneDate(date);
  cloned.setDate(cloned.getDate() + offset);
  return cloned;
}
export var createPreviousDay = date => createDayByOffset(date, -1);
export var createNextDay = date => createDayByOffset(date, 1);
export function createToday() {
  var today = new Date();
  today.setHours(0, 0, 0, 0);
  return today;
}
export var MIN_DATE = createToday();
export var MAX_DATE = new Date(MIN_DATE.getFullYear(), MIN_DATE.getMonth() + 6, 14);
//# sourceMappingURL=calendar.shared.js.map
