var _excluded = ["className", "size", "align", "clickable", "required", "bordered", "icon", "rightIcon", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { cloneIconElement, isIconElement } from "@nickeylin/taroify-icons/utils";
import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { useContext } from "react";
import { prefixClassname } from "../styles";
import CellGroupContext from "./cell-group.context";

function CellBase(props) {
  var {
    className,
    size = "medium",
    align,
    clickable: clickableProp = false,
    required = false,
    bordered = true,
    icon,
    rightIcon,
    children
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    clickable
  } = useContext(CellGroupContext);
  return /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("cell"), {
      [prefixClassname("cell--start")]: align === "start",
      [prefixClassname("cell--center")]: align === "center",
      [prefixClassname("cell--end")]: align === "end",
      [prefixClassname("cell--large")]: size === "large",
      [prefixClassname("cell--clickable")]: clickableProp || clickable,
      [prefixClassname("cell--required")]: required,
      [prefixClassname("cell--borderless")]: !bordered
    }, className)
  }, restProps), icon && isIconElement(icon) ? cloneIconElement(icon, {
    className: prefixClassname("cell__icon")
  }) : icon, children, rightIcon && isIconElement(rightIcon) ? cloneIconElement(rightIcon, {
    className: prefixClassname("cell__right-icon")
  }) : rightIcon);
}

export default CellBase;
//# sourceMappingURL=cell-base.js.map
