import _size2 from "lodash/size";
import _toArray from "lodash/toArray";
var _excluded = ["className", "name", "defaultChecked", "checked", "disabled", "shape", "icon", "size", "children", "onChange"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { useUncontrolled } from "@nickeylin/taroify-hooks";
import { Success } from "@nickeylin/taroify-icons";
import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { useContext } from "react";
import { prefixClassname } from "../styles";
import { addUnitPx } from "../utils/format/unit";
import CheckboxGroupContext from "./checkbox-group.context";
export default function Checkbox(props) {
  var {
    className,
    name,
    defaultChecked,
    checked: checkedProp,
    disabled,
    shape = "round",
    icon = /*#__PURE__*/React.createElement(Success, null),
    size,
    children,
    onChange: onChangeProp
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    value: names,
    max: namesMax = 0,
    direction,
    onChange: onNamesChange
  } = useContext(CheckboxGroupContext);
  var {
    value: checked,
    setValue
  } = useUncontrolled({
    value: checkedProp !== null && checkedProp !== void 0 ? checkedProp : names === null || names === void 0 ? void 0 : names.includes(name),
    defaultValue: defaultChecked,
    onChange: onChangeProp
  });

  function onClick() {
    if (disabled) {
      return;
    }

    setValue(!checked);

    if (name) {
      if (names !== null && names !== void 0 && names.includes(name)) {
        onNamesChange === null || onNamesChange === void 0 ? void 0 : onNamesChange(names.filter(aName => aName !== name));
      } else if (namesMax === 0 || _size2(names) < namesMax) {
        onNamesChange === null || onNamesChange === void 0 ? void 0 : onNamesChange([..._toArray(names), name]);
      }
    }
  }

  return /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("checkbox"), {
      [prefixClassname("checkbox--horizontal")]: direction === "horizontal",
      [prefixClassname("checkbox--vertical")]: direction === "vertical"
    }, className),
    onClick: onClick
  }, restProps), /*#__PURE__*/React.createElement(View, {
    className: classNames(prefixClassname("checkbox__icon"), prefixClassname("checkbox__icon--".concat(shape)), {
      [prefixClassname("checkbox__icon--disabled")]: disabled,
      [prefixClassname("checkbox__icon--checked")]: checked
    }),
    style: {
      fontSize: size ? addUnitPx(size) : ""
    },
    children: icon
  }), children && /*#__PURE__*/React.createElement(View, {
    className: classNames(prefixClassname("checkbox__label"), {
      [prefixClassname("checkbox__label--disabled")]: disabled
    }),
    children: children
  }));
}
//# sourceMappingURL=checkbox.js.map
