var _excluded = ["className", "value", "size", "bordered", "disabled", "clickable", "icon", "expandIcon", "title", "brief", "extra", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { ArrowRight } from "@nickeylin/taroify-icons";
import { View } from "@tarojs/components";
import { nextTick } from "@tarojs/taro";
import classNames from "classnames";
import * as React from "react";
import { useCallback, useContext, useEffect, useMemo, useRef, useState } from "react";
import Cell from "../cell";
import { prefixClassname } from "../styles";
import { getRect } from "../utils/dom/rect";
import { addUnitPx } from "../utils/format/unit";
import { doubleRaf, raf } from "../utils/raf";
import CollapseContext from "./collapse.context";

function CollapseItem(props) {
  var {
    className,
    value,
    size = "medium",
    bordered = true,
    disabled = false,
    clickable = true,
    icon,
    expandIcon = /*#__PURE__*/React.createElement(ArrowRight, null),
    title,
    brief,
    extra,
    children
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var contentRef = useRef();
  var {
    isExpanded,
    toggleItem
  } = useContext(CollapseContext);
  var expanded = isExpanded === null || isExpanded === void 0 ? void 0 : isExpanded(value);
  var [visibility, setVisibility] = useState(expanded);
  var [expandHeight, setExpandHeight] = useState("0");
  var onTransitionEnd = useCallback(() => {
    if (!expanded) {
      setVisibility(false);
    } else {
      setExpandHeight("");
    }
  }, [expanded]);
  useEffect(() => {
    if (expanded) {
      setVisibility(true);
    }

    var tickRaf = expanded ? nextTick : raf;
    tickRaf( /*#__PURE__*/_asyncToGenerator(function* () {
      var {
        height
      } = yield getRect(contentRef);

      if (height) {
        var heightPx = addUnitPx(height);
        setExpandHeight(expanded ? "0" : heightPx);
        doubleRaf(() => {
          setExpandHeight(expanded ? heightPx : "0");
        });
      } else {
        onTransitionEnd();
      }
    }));
  }, [expanded, onTransitionEnd]);
  var toggle = useCallback(function () {
    var newExpanded = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : !expanded;
    toggleItem === null || toggleItem === void 0 ? void 0 : toggleItem(value, newExpanded);
  }, [value, expanded, toggleItem]);
  var onTitleClick = useCallback(() => {
    if (!disabled) {
      toggle();
    }
  }, [disabled, toggle]);
  var wrapperStyle = useMemo(() => ({
    display: visibility ? "" : "none",
    height: expandHeight
  }), [expandHeight, visibility]);
  return /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("collapse-item"), {
      [prefixClassname("collapse-item--bordered")]: value && bordered
    }, className)
  }, restProps), /*#__PURE__*/React.createElement(Cell, {
    className: classNames(prefixClassname("collapse-item__title"), {
      [prefixClassname("collapse-item__title--disabled")]: disabled,
      [prefixClassname("collapse-item__title--expanded")]: expanded,
      [prefixClassname("collapse-item__title--borderless")]: !bordered
    }),
    size: size,
    icon: icon,
    rightIcon: expandIcon,
    title: title,
    clickable: !disabled && clickable,
    brief: brief,
    children: extra,
    onClick: onTitleClick
  }), /*#__PURE__*/React.createElement(View, {
    className: prefixClassname("collapse-item__wrapper"),
    style: wrapperStyle,
    onTransitionEnd: onTransitionEnd
  }, /*#__PURE__*/React.createElement(View, {
    ref: contentRef,
    className: prefixClassname("collapse-item__content"),
    children: children
  })));
}

export default CollapseItem;
//# sourceMappingURL=collapse-item.js.map
