import _size from "lodash/size";
var _excluded = ["className", "bordered", "defaultValue", "value", "accordion", "onChange", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { useUncontrolled } from "@nickeylin/taroify-hooks";
import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { Children, cloneElement, isValidElement, useCallback } from "react";
import { prefixClassname } from "../styles";
import { HAIRLINE_BORDER_TOP_BOTTOM } from "../styles/hairline";
import CollapseItem from "./collapse-item";
import CollapseContext from "./collapse.context";

function validateActiveValue(value, accordion) {
  if (accordion && Array.isArray(value)) {
    console.error('[Taroify] Collapse: "value" should not be Array in accordion mode');
    return false;
  }

  if (!accordion && !Array.isArray(value)) {
    console.error('[Taroify] Collapse: "value" should be Array in non-accordion mode');
    return false;
  }

  return true;
}

function useCollapseChildren(children) {
  var __children__ = {
    items: []
  };
  Children.forEach(children, child => {
    if ( /*#__PURE__*/isValidElement(child)) {
      var element = child;
      var elementType = element.type;

      if (elementType === CollapseItem) {
        var _children__$items;

        var {
          key,
          props
        } = element;

        var index = _size(__children__.items);

        var {
          value
        } = props;
        (_children__$items = __children__.items) === null || _children__$items === void 0 ? void 0 : _children__$items.push( /*#__PURE__*/cloneElement(element, {
          key: key !== null && key !== void 0 ? key : index,
          value: value !== null && value !== void 0 ? value : index
        }));
      } else {
        var _children__$items2;

        (_children__$items2 = __children__.items) === null || _children__$items2 === void 0 ? void 0 : _children__$items2.push(element);
      }
    } else {
      var _children__$items3;

      (_children__$items3 = __children__.items) === null || _children__$items3 === void 0 ? void 0 : _children__$items3.push(child);
    }
  });
  return __children__;
}

function Collapse(props) {
  var {
    className,
    bordered,
    defaultValue,
    value: valueProp,
    accordion = false,
    onChange: onChangeProp,
    children: childrenProp
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    value,
    setValue
  } = useUncontrolled({
    value: valueProp,
    defaultValue,
    onChange: onChangeProp
  });
  var {
    items
  } = useCollapseChildren(childrenProp);
  var toggleItem = useCallback((itemValue, expanded) => {
    if (accordion) {
      setValue(itemValue === value ? "" : itemValue);
    } else if (expanded) {
      setValue(value.concat(itemValue));
    } else {
      setValue(value.filter(activeKey => activeKey !== itemValue));
    }
  }, [accordion, setValue, value]);
  var isExpanded = useCallback(itemValue => {
    if (process.env.NODE_ENV !== "production" && !validateActiveValue(value, accordion)) {
      return false;
    }

    return accordion ? value === itemValue : value.includes(itemValue);
  }, [accordion, value]);
  return /*#__PURE__*/React.createElement(CollapseContext.Provider, {
    value: {
      isExpanded,
      toggleItem
    }
  }, /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("collapse"), {
      [HAIRLINE_BORDER_TOP_BOTTOM]: bordered
    }, className),
    children: items
  }, restProps)));
}

export default Collapse;
//# sourceMappingURL=collapse.js.map
