import _isFunction from "lodash/isFunction";
var _excluded = ["className", "value", "autostart", "interval", "format", "onChange", "onComplete", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { forwardRef, useImperativeHandle, useMemo } from "react";
import { prefixClassname } from "../styles";
import { parseFormat } from "./countdown.shared";
import useCountdown from "./use-countdown";
var Countdown = /*#__PURE__*/forwardRef((props, ref) => {
  var {
    className,
    value = 0,
    autostart = true,
    interval,
    format = "HH:mm:ss",
    onChange,
    onComplete,
    children
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    current,
    pause,
    reset,
    restart,
    start,
    stop
  } = useCountdown({
    value,
    autostart,
    interval,
    onChange,
    onComplete
  });
  useImperativeHandle(ref, () => ({
    pause,
    reset,
    restart,
    start,
    stop
  }), [pause, reset, restart, start, stop]);
  var childrenRender = useMemo(() => {
    if (_isFunction(children)) {
      return children(current);
    }

    if (children) {
      return children;
    }

    if (_isFunction(format)) {
      return format(current);
    }

    if (format) {
      return parseFormat(format, current);
    }
  }, [children, current, format]);
  return /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("countdown"), className),
    children: childrenRender
  }, restProps));
});
export default Countdown;
//# sourceMappingURL=countdown.js.map
