import { ViewProps } from "@tarojs/components/types/View";
import { ReactNode } from "react";
import { DatetimePickerColumnType, DatetimePickerType } from "./datetime-picker.shared";
export interface DatetimePickerProps extends ViewProps {
    type?: DatetimePickerType;
    fields?: DatetimePickerColumnType[];
    defaultValue?: Date;
    value?: Date;
    min?: Date;
    max?: Date;
    readonly?: boolean;
    loading?: boolean;
    siblingCount?: number;
    children?: ReactNode;
    filter?(type: DatetimePickerColumnType, values: string[]): string[];
    formatter?(type: DatetimePickerColumnType, value: string): string;
    onChange?(date: Date): void;
    onConfirm?(date: Date): void;
    onCancel?(date: Date): void;
}
declare function DatetimePicker(props: DatetimePickerProps): JSX.Element;
export default DatetimePicker;
