var _excluded = ["className", "readonly", "loading", "type", "fields", "filter", "formatter", "min", "max", "defaultValue", "value", "siblingCount", "children", "onChange", "onConfirm", "onCancel"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { useUncontrolled } from "@nickeylin/taroify-hooks";
import * as React from "react";
import Picker from "../picker";
import useDatetimePicker from "./use-datetime-picker";

function DatetimePicker(props) {
  var {
    className,
    readonly,
    loading,
    type,
    fields,
    filter,
    formatter,
    min,
    max,
    defaultValue: defaultValueProp,
    value: valueProp,
    siblingCount,
    children,
    onChange: onChangeProp,
    onConfirm: _onConfirm,
    onCancel: _onCancel
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    value: dateValue,
    setValue: setDateValue
  } = useUncontrolled({
    value: valueProp,
    onChange: onChangeProp
  });
  var {
    defaultValue,
    value,
    columns,
    toDate
  } = useDatetimePicker({
    defaultValue: defaultValueProp,
    value: dateValue,
    min,
    max,
    type,
    fields,
    filter,
    formatter
  });
  return /*#__PURE__*/React.createElement(Picker, _objectSpread({
    className: className,
    readonly: readonly,
    loading: loading,
    siblingCount: siblingCount,
    defaultValue: defaultValue,
    value: value,
    onChange: aValue => setDateValue(toDate(aValue)),
    onConfirm: aValue => _onConfirm === null || _onConfirm === void 0 ? void 0 : _onConfirm(toDate(aValue)),
    onCancel: aValue => _onCancel === null || _onCancel === void 0 ? void 0 : _onCancel(toDate(aValue))
  }, restProps), children, /*#__PURE__*/React.createElement(Picker.Columns, {
    children: columns
  }));
}

export default DatetimePicker;
//# sourceMappingURL=datetime-picker.js.map
