export declare type DatetimePickerType = "date" | "time" | "datetime" | "date-hour" | "date-minute" | "year-month" | "month-day" | "hour-minute";
export declare type DatetimePickerColumnType = "year" | "month" | "day" | "hour" | "minute" | "second";
declare type Datetime = [number, number, number, number, number, number];
export declare const MIN_DATE: Date;
export declare const MAX_DATE: Date;
export declare function getEndDayOfMonth(year: number, month: number): number;
export declare function clampDate(value: Date | undefined, minDate: Date, maxDate: Date): Date;
export declare function getDatetime(date: Date): Datetime;
interface DatetimeRange {
    type: DatetimePickerColumnType;
    range: [number, number];
}
export declare function useDatetimeRanges(date: Date | undefined, minDate: Date, maxDate: Date, type: DatetimePickerType, fields: DatetimePickerColumnType[]): DatetimeRange[];
export {};
