import { DatetimePickerColumnType, DatetimePickerType } from "./datetime-picker.shared";
interface UseDatetimePicker {
    type?: DatetimePickerType;
    defaultValue?: Date;
    value?: Date;
    min?: Date;
    max?: Date;
    fields?: DatetimePickerColumnType[];
    filter?(type: DatetimePickerColumnType, values: string[]): string[];
    formatter?(type: DatetimePickerColumnType, value: string): string;
}
export declare function useDatetimePicker(options?: UseDatetimePicker): {
    toDate: (datetimeValue: string[]) => Date;
    defaultValue: string[] | undefined;
    value: string[] | undefined;
    columns: {
        type: DatetimePickerColumnType;
        value: DatetimePickerColumnType;
        children: {
            value: string;
            children: string;
        }[];
    }[];
};
export default useDatetimePicker;
