import _isPlainObject from "lodash/isPlainObject";
import _assign from "lodash/assign";
var _excluded = ["selector"],
    _excluded2 = ["cancel", "confirm"],
    _excluded3 = ["confirm"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { Events } from "@tarojs/taro";
import { isValidElement, useEffect } from "react";
var initialDialogOptions = {
  className: undefined,
  style: undefined,
  backdrop: undefined,
  duration: undefined,
  message: undefined,
  title: undefined,
  messageAlign: undefined,
  confirm: undefined,
  cancel: undefined
};
var DEFAULT_DIALOG_SELECTOR = "#dialog";
var defaultDialogOptions = {};
resetDefaultDialogOptions();
export function setDefaultDialogOptions(options) {
  _assign(defaultDialogOptions, options);
}
export function resetDefaultDialogOptions() {
  _assign(defaultDialogOptions, {
    selector: DEFAULT_DIALOG_SELECTOR
  });
}
var dialogEvents = new Events();
export function useDialogOpen(cb) {
  useEffect(() => {
    dialogEvents.on("open", cb);
    return () => {
      dialogEvents.off("open", cb);
    };
  }, []);
}
export function useDialogCancel(cb) {
  useEffect(() => {
    dialogEvents.on("cancel", cb);
    return () => {
      dialogEvents.off("cancel", cb);
    };
  }, []);
}

function parseDialogOptions(message) {
  var options = ! /*#__PURE__*/isValidElement(message) && _isPlainObject(message) ? message : {
    message
  };
  return _assign({}, initialDialogOptions, defaultDialogOptions, options);
}

export function openDialog(args) {
  var _parseDialogOptions = parseDialogOptions(args),
      {
    selector = "#dialog"
  } = _parseDialogOptions,
      restOptions = _objectWithoutProperties(_parseDialogOptions, _excluded);

  dialogEvents.trigger("open", _objectSpread({
    selector
  }, restOptions));
}
export function confirmDialog(args) {
  var _parseDialogOptions2 = parseDialogOptions(args),
      {
    cancel = "取消",
    confirm = "确定"
  } = _parseDialogOptions2,
      restOptions = _objectWithoutProperties(_parseDialogOptions2, _excluded2);

  return openDialog(_objectSpread({
    confirm,
    cancel
  }, restOptions));
}
export function alertDialog(args) {
  var _parseDialogOptions3 = parseDialogOptions(args),
      {
    confirm = "确定"
  } = _parseDialogOptions3,
      restOptions = _objectWithoutProperties(_parseDialogOptions3, _excluded3);

  return openDialog(_objectSpread({
    confirm
  }, restOptions));
}
export function cancelDialog(selector) {
  dialogEvents.trigger("cancel", selector !== null && selector !== void 0 ? selector : defaultDialogOptions.selector);
}
//# sourceMappingURL=dialog.imperative.js.map
