var _excluded = ["className", "__dataKey__", "disabled", "children", "onClick"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { View } from "@tarojs/components";
import classnames from "classnames";
import * as React from "react";
import { useContext, useMemo } from "react";
import { prefixClassname } from "../styles";
import DropdownMenuContext from "./dropdown-menu.context";

function DropdownMenuTitle(props) {
  var {
    className,
    __dataKey__: dataKey,
    disabled,
    children,
    onClick: _onClick
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    isItemToggle,
    toggleItem
  } = useContext(DropdownMenuContext);
  var active = useMemo(() => isItemToggle === null || isItemToggle === void 0 ? void 0 : isItemToggle(dataKey), [dataKey, isItemToggle]);
  return /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classnames(prefixClassname("dropdown-menu-title"), {
      [prefixClassname("dropdown-menu-title--active")]: active,
      [prefixClassname("dropdown-menu-title--disabled")]: disabled,
      [prefixClassname("dropdown-menu-title--down")]: active
    }, className),
    onClick: event => {
      _onClick === null || _onClick === void 0 ? void 0 : _onClick(event);

      if (!disabled) {
        toggleItem === null || toggleItem === void 0 ? void 0 : toggleItem(dataKey);
      }
    }
  }, restProps), /*#__PURE__*/React.createElement(View, {
    className: prefixClassname("dropdown-menu-title__content")
  }, /*#__PURE__*/React.createElement(View, {
    className: prefixClassname("ellipsis"),
    children: children
  })));
}

export default DropdownMenuTitle;
//# sourceMappingURL=dropdown-menu-title.js.map
