var _excluded = ["className", "style", "span", "offset"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { useContext } from "react";
import { prefixClassname } from "../styles";
import { addUnitPx } from "../utils/format/unit";
import FlexContext from "./flex.context";
export default function FlexItem(props) {
  var {
    className,
    style,
    span,
    offset
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    gutter: gutters
  } = useContext(FlexContext);
  var [horizontalGutter] = gutters;
  var gutterStyle = {};

  if (horizontalGutter) {
    var averagePadding = horizontalGutter / 2;
    gutterStyle.paddingLeft = addUnitPx(averagePadding);
    gutterStyle.paddingRight = addUnitPx(averagePadding);
  }

  return /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("flex-item"), {
      [prefixClassname("flex-item-".concat(span))]: span !== undefined,
      [prefixClassname("flex-item-offset-".concat(offset))]: offset !== undefined
    }, className),
    style: _objectSpread(_objectSpread({}, style), gutterStyle)
  }, restProps));
}
//# sourceMappingURL=flex-item.js.map
