import { ViewProps } from "@tarojs/components/types/View";
import * as React from "react";
import { CSSProperties, ReactNode } from "react";
import { FlexAlign, FlexDirection, FlexGutter, FlexJustify, FlexWrap } from "./flex.shared";
export interface FlexProps extends ViewProps {
    style?: CSSProperties;
    direction?: FlexDirection;
    wrap?: FlexWrap;
    justify?: FlexJustify;
    align?: FlexAlign;
    gutter?: FlexGutter;
    children?: ReactNode;
}
declare const Flex: React.ForwardRefExoticComponent<Pick<FlexProps, "className" | "hoverClass" | "hoverStyle" | "hoverStopPropagation" | "hoverStartTime" | "hoverStayTime" | "id" | "style" | "key" | "hidden" | "animation" | "dangerouslySetInnerHTML" | "onTouchStart" | "onTouchMove" | "onTouchCancel" | "onTouchEnd" | "onClick" | "onLongPress" | "onLongClick" | "onTransitionEnd" | "onAnimationStart" | "onAnimationIteration" | "onAnimationEnd" | "onTouchForceChange" | "children" | "direction" | "catchMove" | "wrap" | "justify" | "align" | "gutter"> & React.RefAttributes<unknown>>;
export default Flex;
