import _isFunction from "lodash/isFunction";
var _excluded = ["className", "name", "value", "align", "children", "onChange", "onBlur"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { Children, isValidElement, useContext, useMemo } from "react";
import Input from "../input";
import { prefixClassname } from "../styles";
import { doFormControlHandler } from "./control";
import FormItemContext from "./form-item.context";
import FormContext from "./form.context";

function FormControl(props) {
  var {
    className,
    name,
    value,
    align: alignProp,
    children = /*#__PURE__*/React.createElement(Input, null),
    onChange: onDelegatingChange,
    onBlur: onDelegatingBlur
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    name: formName,
    controlAlign
  } = useContext(FormContext);
  var align = alignProp !== null && alignProp !== void 0 ? alignProp : controlAlign;
  var {
    validateStatus
  } = useContext(FormItemContext);
  var field = useMemo(() => {
    if (_isFunction(children)) {
      return children === null || children === void 0 ? void 0 : children({
        name,
        value: formName ? value : undefined,
        validateStatus,
        onChange: onDelegatingChange,
        onBlur: onDelegatingBlur
      });
    }

    return Children.map(children, child => {
      if (! /*#__PURE__*/isValidElement(child)) {
        return child;
      }

      var element = child;
      return doFormControlHandler(element, {
        name,
        value,
        validateStatus,
        onChange: onDelegatingChange,
        onBlur: onDelegatingBlur
      });
    });
  }, [children, formName, name, onDelegatingBlur, onDelegatingChange, validateStatus, value]);
  return /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("form-control"), {
      [prefixClassname("form-control--left")]: align === "left",
      [prefixClassname("form-control--center")]: align === "center",
      [prefixClassname("form-control--right")]: align === "right"
    }, className),
    children: field
  }, restProps));
}

export default FormControl;
//# sourceMappingURL=form-control.js.map
