import { FormProps as TaroFormProps } from "@tarojs/components/types/Form";
import * as React from "react";
import { ReactNode } from "react";
import { FormControlAlign, FormInstance, FormLabelAlign, FormValidateTrigger, FormValidError } from "./form.shared";
export interface FormProps extends TaroFormProps {
    name?: string;
    defaultValues?: any;
    values?: any;
    labelAlign?: FormLabelAlign;
    controlAlign?: FormControlAlign;
    validateTrigger?: FormValidateTrigger;
    colon?: boolean;
    children?: ReactNode;
    onValidate?(errors: FormValidError[]): void;
    onValuesChange?(changedValues: any, allValues: any): void;
}
declare const Form: React.ForwardRefExoticComponent<Pick<FormProps, "className" | "id" | "style" | "key" | "hidden" | "animation" | "dangerouslySetInnerHTML" | "onTouchStart" | "onTouchMove" | "onTouchCancel" | "onTouchEnd" | "onClick" | "onLongPress" | "onLongClick" | "onTransitionEnd" | "onAnimationStart" | "onAnimationIteration" | "onAnimationEnd" | "onTouchForceChange" | "children" | "name" | "values" | "onSubmit" | "colon" | "labelAlign" | "defaultValues" | "controlAlign" | "validateTrigger" | "onValidate" | "onValuesChange" | "reportSubmit" | "reportSubmitTimeout" | "onReset"> & React.RefAttributes<FormInstance>>;
export default Form;
