var _excluded = ["__dataIndex__", "className", "style", "icon", "text", "dot", "badge", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { useContext, useMemo } from "react";
import { useBadge, useBadgeWrapper } from "../badge";
import { prefixClassname } from "../styles";
import { HAIRLINE_BORDER } from "../styles/hairline";
import { addUnitPx } from "../utils/format/unit";
import GridContext from "./grid.context";

function useGridItemPercent(columns) {
  return useMemo(() => "".concat(100 / columns, "%"), [columns]);
}

export function GridItem(props) {
  var {
    __dataIndex__ = 0,
    className,
    style: styleProp,
    icon,
    text,
    dot,
    badge,
    children
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    columns,
    gutter,
    bordered,
    centered,
    clickable,
    direction,
    square
  } = useContext(GridContext);
  var IconBadgeWrapper = useBadgeWrapper(icon);
  var Badge = useBadge(badge, {
    dot
  });
  var percent = useGridItemPercent(columns);
  var rootStyle = useMemo(() => {
    var style = _objectSpread({}, styleProp);

    style.flexBasis = "".concat(percent);

    if (square) {
      style.paddingTop = percent;
    } else if (gutter) {
      var gutterValue = addUnitPx(gutter);
      style.paddingRight = gutterValue;

      if (__dataIndex__ >= columns) {
        style.marginTop = gutterValue;
      }
    }

    return style;
  }, [styleProp, percent, square, gutter, __dataIndex__, columns]);
  var contentStyle = useMemo(() => {
    if (square && gutter) {
      var gutterValue = addUnitPx(gutter);
      return {
        right: gutterValue,
        bottom: gutterValue,
        height: "auto"
      };
    }
  }, [square, gutter]);
  return /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("grid-item"), {
      [prefixClassname("grid-item--square")]: square
    }, className),
    style: rootStyle
  }, restProps), /*#__PURE__*/React.createElement(View, {
    style: contentStyle,
    className: classNames(prefixClassname("grid-item__content"), {
      [prefixClassname("grid-item__content--square")]: square,
      [prefixClassname("grid-item__content--centered")]: centered,
      [prefixClassname("grid-item__content--clickable")]: clickable,
      [prefixClassname("grid-item__content--horizontal")]: direction === "horizontal",
      [prefixClassname("grid-item__content--surround")]: bordered && gutter,
      [HAIRLINE_BORDER]: bordered
    })
  }, !children && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(IconBadgeWrapper, {
    className: classNames(prefixClassname("grid-item__icon"))
  }, /*#__PURE__*/React.createElement(Badge, null)), /*#__PURE__*/React.createElement(View, {
    className: prefixClassname("grid-item__text")
  }, text)), children));
}
export default GridItem;
//# sourceMappingURL=grid-item.js.map
