var _excluded = ["className", "style", "columns", "gutter", "bordered", "centered", "clickable", "direction", "square", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { Children, cloneElement, useMemo } from "react";
import { prefixClassname } from "../styles";
import { HAIRLINE_BORDER_TOP } from "../styles/hairline";
import { addUnitPx } from "../utils/format/unit";
import GridContext from "./grid.context";
var DEFAULT_GRID_COLUMNS = 4;

function Grid(props) {
  var {
    className,
    style: styleProp,
    columns = DEFAULT_GRID_COLUMNS,
    gutter,
    bordered = true,
    centered = true,
    clickable = false,
    direction = "vertical",
    square,
    children: childrenProp
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var children = useMemo(() => Children.map(childrenProp, (item, index) => /*#__PURE__*/cloneElement(item, {
    __dataIndex__: index
  })), [childrenProp]);
  var rootStyle = useMemo(() => {
    var style = _objectSpread({}, styleProp);

    if (gutter) {
      style.paddingLeft = addUnitPx(gutter);
    }

    return style;
  }, [gutter, styleProp]);
  return /*#__PURE__*/React.createElement(View, _objectSpread({
    style: rootStyle,
    className: classNames(prefixClassname("grid"), {
      [HAIRLINE_BORDER_TOP]: bordered && gutter === undefined
    }, className)
  }, restProps), /*#__PURE__*/React.createElement(GridContext.Provider, {
    value: {
      bordered,
      centered,
      columns,
      clickable,
      direction,
      gutter,
      square
    }
  }, children));
}

export default Grid;
//# sourceMappingURL=grid.js.map
