import _isFunction from "lodash/isFunction";
import { nextTick } from "@tarojs/taro";
import { useEffect, useRef } from "react";

function useRenderedEffect(effect, deps) {
  var destructorRef = useRef();
  useEffect(() => {
    nextTick(() => {
      var destructor = effect === null || effect === void 0 ? void 0 : effect();

      if (_isFunction(destructor)) {
        destructorRef.current = destructor;
      }
    });
    return destructorRef.current;
  }, deps);
}

export default useRenderedEffect;
//# sourceMappingURL=use-rendered-effect.js.map
