import _isString from "lodash/isString";
import _isNumber from "lodash/isNumber";
import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { cloneElement, isValidElement } from "react";
import { prefixClassname } from "../styles";
export default function ImagePlaceholder(props) {
  var {
    prefix = "placeholder",
    children
  } = props;

  if ( /*#__PURE__*/isValidElement(children)) {
    return /*#__PURE__*/cloneElement(children, {
      className: classNames(prefixClassname("image__".concat(prefix)), prefixClassname("image__".concat(prefix, "-icon")))
    });
  }

  if (_isString(children) || _isNumber(children)) {
    return /*#__PURE__*/React.createElement(View, {
      className: prefixClassname("image__".concat(prefix)),
      children: children
    });
  }

  return /*#__PURE__*/React.createElement(React.Fragment, null);
}
//# sourceMappingURL=image-placeholder.js.map
