import _range from "lodash/range";
var _excluded = ["className", "size", "type", "direction", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { useMemo } from "react";
import { prefixClassname } from "../styles";
import { addUnitPx } from "../utils/format/unit";

var SpinIcon = _range(0, 12).map(key => /*#__PURE__*/React.createElement(View, {
  key: key,
  className: prefixClassname("loading__spinner__item")
}));

function LoadingSpinner(props) {
  var {
    size
  } = props;
  var rootStyle = useMemo(() => {
    var _addUnitPx, _addUnitPx2;

    return {
      width: (_addUnitPx = addUnitPx(size)) !== null && _addUnitPx !== void 0 ? _addUnitPx : "",
      height: (_addUnitPx2 = addUnitPx(size)) !== null && _addUnitPx2 !== void 0 ? _addUnitPx2 : ""
    };
  }, [size]);
  return /*#__PURE__*/React.createElement(View, {
    className: prefixClassname("loading__spinner"),
    style: rootStyle
  }, SpinIcon);
}

function LoadingCircular(props) {
  var {
    size
  } = props;
  var rootStyle = useMemo(() => {
    var _addUnitPx3, _addUnitPx4;

    return {
      width: (_addUnitPx3 = addUnitPx(size)) !== null && _addUnitPx3 !== void 0 ? _addUnitPx3 : "",
      height: (_addUnitPx4 = addUnitPx(size)) !== null && _addUnitPx4 !== void 0 ? _addUnitPx4 : ""
    };
  }, [size]);
  return /*#__PURE__*/React.createElement(View, {
    className: prefixClassname("loading__circular"),
    style: rootStyle
  });
}

export default function Loading(props) {
  var {
    className,
    size,
    type = "circular",
    direction = "horizontal",
    children
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  return /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("loading"), prefixClassname("loading--".concat(direction)), prefixClassname("loading--".concat(type)), className)
  }, restProps), type === "spinner" && /*#__PURE__*/React.createElement(LoadingSpinner, {
    size: size
  }), type === "circular" && /*#__PURE__*/React.createElement(LoadingCircular, {
    size: size
  }), children && /*#__PURE__*/React.createElement(View, {
    className: prefixClassname("loading__text"),
    children: children
  }));
}
//# sourceMappingURL=loading.js.map
