var _excluded = ["className", "bordered", "fixed", "placeholder", "safeArea", "title", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { Children, isValidElement, useMemo } from "react";
import FixedView from "../fixed-view";
import { prefixClassname } from "../styles";
import { HAIRLINE_BORDER_BOTTOM } from "../styles/hairline";
import NavBarLeft from "./navbar-left";
import NavBarRight from "./navbar-right";
import NavBarTitle from "./navbar-title";

function useNavbarChildren(children) {
  return useMemo(() => {
    var __children__ = {
      left: undefined,
      right: undefined,
      title: undefined
    };
    Children.forEach(children, child => {
      if ( /*#__PURE__*/isValidElement(child)) {
        var element = child;
        var {
          type
        } = element;

        if (type === NavBarLeft) {
          __children__.left = element;
        } else if (type === NavBarRight) {
          __children__.right = element;
        } else if (type === NavBarTitle) {
          __children__.title = element;
        }
      }
    });
    return __children__;
  }, [children]);
}

function Navbar(props) {
  var {
    className,
    bordered,
    fixed,
    placeholder = true,
    safeArea,
    title: titleProp,
    children: childrenProp
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    left,
    title,
    right
  } = useNavbarChildren(childrenProp);
  return /*#__PURE__*/React.createElement(FixedView, {
    position: fixed && "top",
    safeArea: safeArea,
    placeholder: fixed && placeholder && prefixClassname("navbar__placeholder")
  }, /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("navbar"), {
      [HAIRLINE_BORDER_BOTTOM]: bordered
    }, className)
  }, restProps), /*#__PURE__*/React.createElement(View, {
    className: classNames(prefixClassname("navbar__content"))
  }, left, title !== null && title !== void 0 ? title : /*#__PURE__*/React.createElement(View, {
    className: classNames(prefixClassname("navbar__title")),
    children: titleProp
  }), right)));
}

export default Navbar;
//# sourceMappingURL=navbar.js.map
