import { CSSProperties, ReactNode } from "react";
import { NotifyColor } from "./notify.shared";
export declare function setDefaultNotifyOptions(options: NotifyOptions): void;
export declare function resetDefaultNotifyOptions(): void;
export declare function useNotifyOpen(cb: (options: NotifyOptions) => void): void;
export declare function useNotifyClose(cb: (selector: string) => void): void;
export interface NotifyOptions {
    selector?: string;
    className?: string;
    style?: CSSProperties;
    color?: NotifyColor;
    duration?: number;
    message?: ReactNode;
    onClose?(opened: boolean): void;
}
export declare function openNotify(args: ReactNode | NotifyOptions): void;
export declare function createNotify(color: NotifyColor): (args: string | Omit<NotifyOptions, "color">) => void;
export declare function closeNotify(selector?: string): void;
