var _excluded = ["id", "className", "defaultOpen", "open", "duration", "color", "children", "onClose"],
    _excluded2 = ["selector", "message"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { useUncontrolled } from "@nickeylin/taroify-hooks";
import classNames from "classnames";
import * as React from "react";
import { useEffect } from "react";
import { useTimeout } from "../hooks";
import Popup from "../popup";
import { prefixClassname } from "../styles";
import { getElementSelector, matchSelector, prependPageSelector, usePrependPageSelector } from "../utils/dom/element";
import { useObject, useToRef } from "../utils/state";
import { useNotifyClose, useNotifyOpen } from "./notify.imperative";
var PRESET_COLORS = ["primary", "success", "warning", "danger"];

function Notify(props) {
  var _useObject = useObject(props),
      {
    object: {
      id,
      className,
      defaultOpen,
      open: openProp,
      duration = 3000,
      color = "danger",
      children,
      onClose
    },
    setObject
  } = _useObject,
      restProps = _objectWithoutProperties(_useObject.object, _excluded);

  var rootSelectorRef = useToRef(usePrependPageSelector(getElementSelector(id)));
  var {
    value: open = false,
    setValue: setOpen
  } = useUncontrolled({
    defaultValue: defaultOpen,
    value: openProp,
    onChange: aOpened => !aOpened && (onClose === null || onClose === void 0 ? void 0 : onClose(aOpened))
  });
  var {
    stop: stopAutoClose,
    restart: restartAutoClose
  } = useTimeout();
  useEffect(() => {
    if (open) {
      restartAutoClose(() => {
        setOpen(false);
        stopAutoClose();
      }, duration);
    } else {
      stopAutoClose();
    }

    return () => stopAutoClose();
  }, [duration, open, restartAutoClose, setObject, setOpen, stopAutoClose]);
  useNotifyOpen(_ref => {
    var {
      selector,
      message
    } = _ref,
        restOptions = _objectWithoutProperties(_ref, _excluded2);

    if (matchSelector(prependPageSelector(selector), rootSelectorRef.current)) {
      restartAutoClose();
      setObject(_objectSpread({
        children: message
      }, restOptions));
      setOpen(true);
    }
  });
  useNotifyClose(selector => {
    if (matchSelector(prependPageSelector(selector), rootSelectorRef.current)) {
      setOpen(false);
    }
  });
  return /*#__PURE__*/React.createElement(Popup, _objectSpread({
    id: id,
    className: classNames(prefixClassname("notify"), {
      [prefixClassname("notify--".concat(color))]: PRESET_COLORS.includes(color)
    }, className),
    placement: "top",
    open: open,
    duration: 200
  }, restProps), /*#__PURE__*/React.createElement(Popup.Backdrop, {
    open: false
  }), children);
}

export default Notify;
//# sourceMappingURL=notify.js.map
