var _excluded = ["className", "type", "children", "onClick"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { useContext } from "react";
import { prefixClassname } from "../styles";
import NumberKeyboardContext from "./number-keyboard.context";

function NumberKeyboardButton(props) {
  var {
    className,
    type = "hide",
    children,
    onClick
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    onKeyPress
  } = useContext(NumberKeyboardContext);

  function handleClick(event) {
    onClick === null || onClick === void 0 ? void 0 : onClick(event);

    if (type === "hide") {
      onKeyPress === null || onKeyPress === void 0 ? void 0 : onKeyPress(children, "keyboard-hide");
    }
  }

  return /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames({
      [prefixClassname("number-keyboard__hide")]: type === "hide"
    }, className),
    children: children,
    onClick: handleClick
  }, restProps));
}

export default NumberKeyboardButton;
//# sourceMappingURL=number-keyboard-button.js.map
