var _excluded = ["className", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { Children, isValidElement, useContext, useMemo } from "react";
import { prefixClassname } from "../styles";
import NumberKeyboardButton from "./number-keyboard-button";
import NumberKeyboardContext from "./number-keyboard.context";

function useNumberKeyboardHeaderChildren(children) {
  var {
    title
  } = useContext(NumberKeyboardContext);
  return useMemo(() => {
    var __children__ = {
      title: title && /*#__PURE__*/React.createElement(View, {
        className: prefixClassname("number-keyboard__title"),
        children: title
      })
    };
    Children.forEach(children, child => {
      if ( /*#__PURE__*/isValidElement(child)) {
        var element = child;
        var elementType = element.type;

        if (elementType === NumberKeyboardButton) {
          var {
            type
          } = element.props;

          if (type === undefined || type === "hide") {
            __children__.right = element;
          }
        }
      }
    });
    return __children__;
  }, [children, title]);
}

function NumberKeyboardHeader(props) {
  var {
    className,
    children: childrenProp
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    left,
    title,
    right
  } = useNumberKeyboardHeaderChildren(childrenProp);
  return /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("number-keyboard__header"), className)
  }, restProps), left, title, right);
}

export default NumberKeyboardHeader;
//# sourceMappingURL=number-keyboard-header.js.map
