import { ViewProps } from "@tarojs/components/types/View";
import { CSSProperties, ReactElement, ReactNode } from "react";
import { ItemType, Page as SharedPage } from "./pagination.shared";
export declare function makePageItems(start: number, end: number): ReactElement[];
interface PaginationProps extends ViewProps {
    className?: string;
    current?: number;
    count?: number;
    siblingCount?: number;
    children?: ReactNode;
    onChange?: (page: number) => void;
}
declare function Pagination(props: PaginationProps): JSX.Element;
declare namespace Pagination {
    export type Page = SharedPage;
    interface BaseItemProps {
        className?: string;
        style?: CSSProperties;
        hidden?: boolean;
        disabled?: boolean;
        children?: ReactNode;
        onClick?: () => void;
    }
    type ItemTypeString = "page" | "first" | "last" | "previous" | "next" | "start-ellipsis" | "end-ellipsis";
    interface ItemProps extends BaseItemProps {
        type?: ItemType | ItemTypeString;
        page?: number;
    }
    export function Item(props: ItemProps): JSX.Element;
    export {};
}
export default Pagination;
