import _isEmpty from "lodash/isEmpty";
var _excluded = ["className", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { Children, cloneElement, isValidElement, useMemo } from "react";
import { prefixClassname } from "../styles";
import PickerButton, { PickerButtonType } from "./picker-button";
import PickerTitle from "./picker-title";

function usePickerToolbarChildren(children) {
  return useMemo(() => {
    var __children__ = {
      title: undefined,
      cancel: undefined,
      confirm: undefined
    };
    Children.forEach(children, (child, index) => {
      if ( /*#__PURE__*/isValidElement(child)) {
        var element = child;
        var {
          type: elementType
        } = element;

        if (elementType === PickerTitle) {
          __children__.title = element;
        } else if (elementType === PickerButton) {
          var {
            props
          } = element;
          var {
            type
          } = props;

          if (type === PickerButtonType.Cancel) {
            __children__.cancel = element;
          } else if (type === PickerButtonType.Confirm) {
            __children__.confirm = element;
          } else if (_isEmpty(type) && _isEmpty(__children__.cancel)) {
            __children__.cancel = /*#__PURE__*/cloneElement(element, {
              type: PickerButtonType.Cancel
            });
          } else if (_isEmpty(type) && _isEmpty(__children__.confirm)) {
            __children__.confirm = /*#__PURE__*/cloneElement(element, {
              type: PickerButtonType.Confirm
            });
          }
        }
      }
    });
    return __children__;
  }, [children]);
}

export default function PickerToolbar(props) {
  var {
    className,
    children: childrenProp
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    title,
    cancel,
    confirm
  } = usePickerToolbarChildren(childrenProp);
  return /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("picker__toolbar"), className)
  }, restProps), cancel, title, confirm);
}
//# sourceMappingURL=picker-toolbar.js.map
