import { ViewProps } from "@tarojs/components/types/View";
import { ReactNode } from "react";
import { PickerOptionObject } from "./picker.shared";
interface PickerBaseProps extends ViewProps {
    readonly?: boolean;
    loading?: boolean;
    siblingCount?: number;
    children?: ReactNode;
}
export interface MultiValuePickerProps extends PickerBaseProps {
    defaultValue?: any[];
    value?: any[];
    onChange?(values: any[], option: PickerOptionObject, column: PickerOptionObject): void;
    onConfirm?(values: any[], options: PickerOptionObject[]): void;
    onCancel?(values: any[], options: PickerOptionObject[]): void;
}
export interface PickerProps extends PickerBaseProps {
    defaultValue?: any | any[];
    value?: any | any[];
    onChange?(values: any | any[], option: PickerOptionObject, column: PickerOptionObject): void;
    onConfirm?(values: any | any[], option: PickerOptionObject | PickerOptionObject[]): void;
    onCancel?(values: any | any[], option: PickerOptionObject | PickerOptionObject[]): void;
}
declare function Picker(props: PickerProps): JSX.Element;
export default Picker;
