import _isUndefined from "lodash/isUndefined";
import _isNumber from "lodash/isNumber";
import _gte from "lodash/gte";
import _first from "lodash/first";
import { isTextElement } from "../utils/validate";
export var DEFAULT_SIBLING_COUNT = 3;
var DEFAULT_COLUMN_INDEX = 0;
export function validPickerColumn(column) {
  var {
    index
  } = column;
  return _isNumber(index) && _gte(index, DEFAULT_COLUMN_INDEX) ? column : undefined;
}
export function getPickerOptionKey(option) {
  var _ref;

  var {
    key,
    value,
    label,
    children
  } = option;
  var newKey = (_ref = key !== null && key !== void 0 ? key : value) !== null && _ref !== void 0 ? _ref : label;

  if (_isUndefined(newKey) && isTextElement(children)) {
    return children;
  }

  return newKey;
}
export function getPickerValue(values, multiColumns) {
  return multiColumns ? values : _first(values);
}
//# sourceMappingURL=picker.shared.js.map
