import { ITouchEvent } from "@tarojs/components";
import { BaseEventOrig } from "@tarojs/components/types/common";
import { InputProps } from "@tarojs/components/types/Input";
import { ViewProps } from "@tarojs/components/types/View";
import { ReactElement, ReactNode, ReactText } from "react";
import { FormFeedbackProps } from "../form";
import { InputAlign, InputClearTrigger, InputColor } from "../input";
import { SearchShape } from "./search.shared";
interface SearchProps extends ViewProps {
    className?: string;
    value?: string;
    icon?: ReactNode;
    rightIcon?: ReactNode;
    label?: ReactNode;
    shape?: SearchShape;
    maxlength?: number;
    autoFocus?: boolean;
    focus?: boolean;
    disabled?: boolean;
    readonly?: boolean;
    placeholder?: string;
    placeholderClassName?: string;
    inputAlign?: InputAlign;
    inputColor?: InputColor;
    clearable?: boolean;
    clearIcon?: ReactNode;
    clearTrigger?: InputClearTrigger;
    feedback?: ReactText | FormFeedbackProps | ReactElement;
    action?: boolean | ReactNode;
    onClear?(event: ITouchEvent): void;
    onCancel?(event: ITouchEvent): void;
    onSearch?(event: BaseEventOrig<InputProps.inputValueEventDetail>): void;
    onChange?(event: BaseEventOrig<InputProps.inputEventDetail>): void;
    onFocus?(event: BaseEventOrig<InputProps.inputForceEventDetail>): void;
    onBlur?(event: BaseEventOrig<InputProps.inputValueEventDetail>): void;
}
declare function Search(props: SearchProps): JSX.Element;
export default Search;
