var _excluded = ["className", "size", "justify", "align", "direction", "wrap", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import classNames from "classnames";
import * as React from "react";
import { Children } from "react";
import Flex from "../flex";
import { prefixClassname } from "../styles";
export default function Space(props) {
  var {
    className,
    size = "small",
    justify,
    align,
    direction = "horizontal",
    wrap = "wrap",
    children
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  return /*#__PURE__*/React.createElement(Flex, _objectSpread({
    className: classNames(prefixClassname("space"), {
      [prefixClassname("space--horizontal")]: direction === "horizontal",
      [prefixClassname("space--vertical")]: direction === "vertical",
      [prefixClassname("space--mini")]: size === "mini",
      [prefixClassname("space--small")]: size === "small",
      [prefixClassname("space--medium")]: size === "medium",
      [prefixClassname("space--large")]: size === "large"
    }, className),
    direction: direction === "horizontal" ? "row" : direction === "vertical" ? "column" : undefined,
    justify: justify,
    align: align,
    wrap: wrap
  }, restProps), Children.map(children, (item, index) => /*#__PURE__*/React.createElement(Flex.Item, {
    key: index,
    className: classNames(prefixClassname("space__item"), {
      [prefixClassname("space__item--mini")]: size === "mini",
      [prefixClassname("space__item--small")]: size === "small",
      [prefixClassname("space__item--medium")]: size === "medium",
      [prefixClassname("space__item--large")]: size === "large"
    }),
    children: item
  })));
}
//# sourceMappingURL=space.js.map
