var _excluded = ["className", "index", "active", "completed", "icon", "label", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { cloneIconElement } from "@nickeylin/taroify-icons/utils";
import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { useContext, useMemo } from "react";
import { prefixClassname } from "../styles";
import { HAIRLINE_BORDER } from "../styles/hairline";
import StepsContext from "./steps.context";

function Step(props) {
  var {
    className,
    index = -1,
    active: activeProp = false,
    completed: completedProp = false,
    icon,
    label,
    children
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    value = -1,
    direction,
    alternativeLabel
  } = useContext(StepsContext);
  var active = useMemo(() => activeProp || index === value, [activeProp, index, value]);
  var completed = useMemo(() => completedProp || index < value, [completedProp, index, value]);
  return /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(HAIRLINE_BORDER, prefixClassname("step"), prefixClassname("step--".concat(direction)), {
      [prefixClassname("step--alternative-label")]: alternativeLabel && direction === "horizontal",
      [prefixClassname("step--active")]: active,
      [prefixClassname("step--completed")]: completed
    }, className)
  }, restProps), /*#__PURE__*/React.createElement(View, {
    className: classNames(prefixClassname("step__label")),
    children: children !== null && children !== void 0 ? children : label
  }), /*#__PURE__*/React.createElement(View, {
    className: prefixClassname("step__circle-container")
  }, icon ? cloneIconElement(icon, {
    className: prefixClassname("step__icon")
  }) : /*#__PURE__*/React.createElement(View, {
    className: prefixClassname("step__circle")
  })), /*#__PURE__*/React.createElement(View, {
    className: classNames(prefixClassname("step__line"))
  }));
}

export default Step;
//# sourceMappingURL=step.js.map
