var _excluded = ["className", "defaultValue", "value", "direction", "alternativeLabel", "children"];

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { useUncontrolled } from "@nickeylin/taroify-hooks";
import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { Children, cloneElement, isValidElement } from "react";
import { prefixClassname } from "../styles";
import Step from "./step";
import StepsContext from "./steps.context";

function useStepsChildren(children) {
  var __children__ = {
    steps: []
  };
  var index = 0;
  Children.forEach(children, (child, i) => {
    if (! /*#__PURE__*/isValidElement(child)) {
      return;
    }

    var element = child;
    var elementType = element.type;

    if (elementType === Step) {
      var {
        key
      } = element;

      __children__.steps.push( /*#__PURE__*/cloneElement(child, _objectSpread(_objectSpread({}, element.props), {}, {
        key: key !== null && key !== void 0 ? key : i,
        index: index++
      })));
    }
  });
  return __children__;
}

function Steps(props) {
  var {
    className,
    defaultValue,
    value: valueProp,
    direction = "horizontal",
    alternativeLabel = false,
    children: childrenProp
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    value
  } = useUncontrolled({
    value: valueProp,
    defaultValue
  });
  var {
    steps
  } = useStepsChildren(childrenProp);
  return /*#__PURE__*/React.createElement(StepsContext.Provider, {
    value: {
      value,
      direction,
      alternativeLabel
    }
  }, /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("steps"), {
      [prefixClassname("steps--horizontal")]: direction === "horizontal",
      [prefixClassname("steps--vertical")]: direction === "vertical"
    }, className)
  }, restProps), /*#__PURE__*/React.createElement(View, {
    className: prefixClassname("steps__items"),
    children: steps
  })));
}

export default Steps;
//# sourceMappingURL=steps.js.map
