import { ViewProps } from "@tarojs/components/types/View";
import { PageScrollObject } from "@tarojs/taro";
import { CSSProperties, MutableRefObject, ReactNode } from "react";
declare type StickyPosition = "top" | "bottom";
interface StickyOffset {
    top?: number | string;
    bottom?: number | string;
}
interface StickyProps extends ViewProps {
    className?: string;
    style?: CSSProperties;
    position?: StickyPosition;
    offset?: StickyOffset;
    offsetTop?: number | string;
    offsetBottom?: number | string;
    container?: MutableRefObject<Element | undefined>;
    children?: ReactNode;
    onChange?(fixed: boolean): void;
    onScroll?(scroll: PageScrollObject): void;
}
export default function Sticky(props: StickyProps): JSX.Element;
export {};
