var _excluded = ["__dataIndex__", "className", "style", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { useContext, useEffect, useMemo, useRef, useState } from "react";
import { useMounted } from "../hooks";
import { prefixClassname } from "../styles";
import { addUnitPx } from "../utils/format/unit";
import { useRendered } from "../utils/state";
import SwiperContext from "./swiper.context";
export default function SwiperItem(props) {
  var {
    __dataIndex__ = 0,
    className,
    style: styleProp,
    children: childrenProp
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    lazyRender,
    getSize,
    direction,
    loop,
    indicator = 0,
    count = 0,
    itemInstances
  } = useContext(SwiperContext);
  var vertical = direction === "vertical";
  var initializedRef = useRef(false);
  var mountedRef = useRef(false);
  var [offset, setOffset] = useState(0);
  var shouldRender = useMemo(() => {
    if (!lazyRender || initializedRef.current) {
      return true;
    }

    if (!mountedRef.current && indicator !== 0) {
      return false;
    }

    var active = indicator;
    var maxActive = count - 1;
    var prevActive = active === 0 && loop ? maxActive : active - 1;
    var nextActive = active === maxActive && loop ? 0 : active + 1;
    initializedRef.current = __dataIndex__ === active || __dataIndex__ === prevActive || __dataIndex__ === nextActive;
    return initializedRef.current;
  }, [__dataIndex__, count, indicator, lazyRender, loop]);
  useMounted(() => {
    mountedRef.current = true;
  });
  useEffect(() => {
    if (!itemInstances[__dataIndex__]) {
      itemInstances[__dataIndex__] = {
        setOffset
      };
    }
  }, [itemInstances, __dataIndex__]);
  var rootStyle = useRendered(() => {
    var style = {};
    var size = getSize === null || getSize === void 0 ? void 0 : getSize();

    if (size) {
      var mainAxis = vertical ? "height" : "width";
      style[mainAxis] = addUnitPx(size);
    }

    style.transform = offset ? "translate".concat(vertical ? "Y" : "X", "(").concat(addUnitPx(offset), ")") : "";
    return style;
  });
  return /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("swiper-item"), className),
    style: _objectSpread(_objectSpread({}, styleProp), rootStyle),
    children: shouldRender ? childrenProp : undefined
  }, restProps));
}
//# sourceMappingURL=swiper-item.js.map
