var _excluded = ["className", "style", "defaultChecked", "checked", "loading", "disabled", "size", "onChange", "onClick"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { useUncontrolled } from "@nickeylin/taroify-hooks";
import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import Loading from "../loading";
import { prefixClassname } from "../styles";
import { addUnitPx } from "../utils/format/unit";

function Switch(props) {
  var {
    className,
    style,
    defaultChecked,
    checked: checkedProp,
    loading = false,
    disabled = false,
    size,
    onChange: onChangeProp,
    onClick
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    value: checked = false,
    setValue
  } = useUncontrolled({
    value: checkedProp,
    defaultValue: defaultChecked,
    onChange: onChangeProp
  });

  function handleClick(event) {
    onClick === null || onClick === void 0 ? void 0 : onClick(event);

    if (disabled || loading) {
      return;
    }

    setValue(!checked);
  }

  return /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("switch"), {
      [prefixClassname("switch--checked")]: checked,
      [prefixClassname("switch--loading")]: loading,
      [prefixClassname("switch--disabled")]: disabled
    }, className),
    style: _objectSpread({
      fontSize: addUnitPx(size)
    }, style),
    onClick: handleClick
  }, restProps), /*#__PURE__*/React.createElement(View, {
    className: prefixClassname("switch__node")
  }, loading && /*#__PURE__*/React.createElement(Loading, {
    className: prefixClassname("switch__loading")
  })));
}

export default Switch;
//# sourceMappingURL=switch.js.map
