var _excluded = ["className", "defaultValue", "value", "bordered", "fixed", "placeholder", "safeArea", "children", "onChange"];

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { useUncontrolled } from "@nickeylin/taroify-hooks";
import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { Children, cloneElement, isValidElement, useMemo } from "react";
import FixedView from "../fixed-view";
import { prefixClassname } from "../styles";
import { HAIRLINE_BORDER_TOP_BOTTOM } from "../styles/hairline";
import TabbarItem from "./tabbar-item";
import TabbarContext from "./tabbar.context";

function useTabbarChildren(children) {
  return useMemo(() => Children.map(children, (node, index) => {
    var _element$key;

    if (! /*#__PURE__*/isValidElement(node)) {
      return node;
    }

    var element = node;

    if (element.type !== TabbarItem) {
      return element;
    }

    var {
      props
    } = element;
    return /*#__PURE__*/cloneElement(element, _objectSpread({
      value: (_element$key = element.key) !== null && _element$key !== void 0 ? _element$key : index
    }, props));
  }), [children]);
}

function Tabbar(props) {
  var {
    className,
    defaultValue,
    value: valueProp,
    bordered,
    fixed,
    placeholder = true,
    safeArea,
    children: childrenProp,
    onChange: onChangeProp
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    value = 0,
    setValue
  } = useUncontrolled({
    value: valueProp,
    defaultValue,
    onChange: onChangeProp
  });
  var children = useTabbarChildren(childrenProp);

  function onItemClick(dataKey) {
    if (dataKey !== value) {
      setValue(dataKey);
    }
  }

  return /*#__PURE__*/React.createElement(TabbarContext.Provider, {
    value: {
      value,
      onItemClick
    }
  }, /*#__PURE__*/React.createElement(FixedView, {
    position: fixed,
    safeArea: safeArea,
    placeholder: fixed && placeholder && prefixClassname("tabbar__placeholder")
  }, /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("tabbar"), {
      [HAIRLINE_BORDER_TOP_BOTTOM]: bordered
    }, className),
    children: children
  }, restProps))));
}

export default Tabbar;
//# sourceMappingURL=tabbar.js.map
