var _excluded = ["className", "style", "index", "value", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { useContext, useMemo, useRef } from "react";
import { prefixClassname } from "../styles";
import Swiper from "../swiper";
import TabsContext from "./tabs.context";
export default function TabPaneBase(props) {
  var {
    className,
    style,
    index,
    value,
    children
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    index: activeIndex,
    value: activeValue,
    lazyRender,
    animated,
    swipeable
  } = useContext(TabsContext);
  var active = activeValue === value;
  var initializedRef = useRef(false);
  var shouldRender = useMemo(() => {
    if (!lazyRender) {
      return true;
    }

    if (initializedRef.current) {
      return true;
    }

    if ((index - 1 === activeIndex || index + 1 === activeIndex) && !initializedRef.current) {
      initializedRef.current = true;
      return true;
    }

    if (active && !initializedRef.current) {
      initializedRef.current = true;
    }

    return active;
  }, [active, activeIndex, index, lazyRender]);
  var tabPane = /*#__PURE__*/React.createElement(View, _objectSpread({
    style: _objectSpread(_objectSpread({}, style), {}, {
      display: !(animated || swipeable) && !active ? "none" : ""
    }),
    className: classNames(prefixClassname("tabs__tab-pane"), className),
    children: shouldRender ? children : undefined
  }, restProps));

  if (animated || swipeable) {
    return /*#__PURE__*/React.createElement(Swiper.Item, {
      className: classNames(prefixClassname("tabs__tab-pane-wrapper"), {
        [prefixClassname("tabs__tab-pane-wrapper--inactive")]: !active
      }),
      children: tabPane
    });
  }

  return tabPane;
}
//# sourceMappingURL=tab-pane-base.js.map
