var _excluded = ["className", "active", "disabled", "underline", "ellipsis", "flexBasis", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { prefixClassname } from "../styles";
import TabsLine from "./tabs-line";
export default function Tab(props) {
  var {
    className,
    active,
    disabled = false,
    underline,
    ellipsis,
    flexBasis,
    children
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  return /*#__PURE__*/React.createElement(View, _objectSpread({
    style: {
      flexBasis
    },
    className: classNames(prefixClassname("tabs__tab"), {
      [prefixClassname("tabs__tab--active")]: active,
      [prefixClassname("tabs__tab--disabled")]: disabled
    }, className)
  }, restProps), /*#__PURE__*/React.createElement(View, {
    className: classNames(prefixClassname("tabs__tab__content"), {
      [prefixClassname("ellipsis")]: ellipsis
    }),
    children: children
  }), underline && /*#__PURE__*/React.createElement(TabsLine, {
    active: active
  }));
}
//# sourceMappingURL=tab.js.map
