import _map from "lodash/map";
import _get from "lodash/get";
import _find from "lodash/find";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { useMemo } from "react";
import { prefixClassname } from "../styles";
import Swiper from "../swiper";
import { useRendered } from "../utils/state";
import TabPaneBase from "./tab-pane-base";

function useTabPanes(tabObjects) {
  return useMemo(() => _map(tabObjects, props => /*#__PURE__*/React.createElement(TabPaneBase, _objectSpread({}, props))), [tabObjects]);
}

export function TabsContent(props) {
  var {
    value: activeValue,
    duration,
    animated,
    swipeable,
    tabObjects,
    onTabChange
  } = props;
  var activeIndex = useMemo(() => {
    var _find2;

    return (_find2 = _find(tabObjects, tab => tab.value === activeValue)) === null || _find2 === void 0 ? void 0 : _find2.index;
  }, [activeValue, tabObjects]);
  var panes = useTabPanes(tabObjects);

  function onSwiperChange(index) {
    var tabObject = _get(tabObjects, index);

    if (tabObject) {
      var {
        value,
        title,
        disabled
      } = tabObject;

      if (!disabled) {
        onTabChange === null || onTabChange === void 0 ? void 0 : onTabChange({
          value,
          title,
          disabled
        });
      }
    }
  }

  var childrenRender = useRendered(() => {
    if (animated || swipeable) {
      return /*#__PURE__*/React.createElement(Swiper, {
        value: activeIndex,
        loop: false,
        className: prefixClassname("tabs__track"),
        duration: duration,
        touchable: swipeable,
        children: panes,
        stopPropagation: false,
        onChange: onSwiperChange
      });
    }

    return panes;
  });
  return /*#__PURE__*/React.createElement(View, {
    className: classNames(prefixClassname("tabs__content"), {
      [prefixClassname("tabs__content--animated")]: animated
    }),
    children: childrenRender
  });
}
//# sourceMappingURL=tabs-content.js.map
