import { ITouchEvent } from "@tarojs/components";
import { ViewProps } from "@tarojs/components/types/View";
import { ReactNode } from "react";
declare type TagVariant = "contained" | "outlined";
declare type TagColor = "default" | "primary" | "info" | "success" | "warning" | "danger";
declare type TagSize = "small" | "medium" | "large";
declare type TagShape = "square" | "rounded" | "roundedRight" | "roundedLeft";
interface TagProps extends ViewProps {
    variant?: TagVariant;
    size?: TagSize;
    color?: TagColor;
    shape?: TagShape;
    closeIcon?: ReactNode;
    closeable?: boolean;
    children?: ReactNode;
    onClose?(event: ITouchEvent): void;
}
declare function Tag(props: TagProps): JSX.Element;
export default Tag;
