var _excluded = ["className", "justify", "align"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import classNames from "classnames";
import * as React from "react";
import Flex from "../flex";
import { prefixClassname } from "../styles";

function TimeLineContent(props) {
  var {
    className,
    justify,
    align
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  return /*#__PURE__*/React.createElement(Flex, _objectSpread({
    className: classNames(prefixClassname("timeline-content"), {
      [prefixClassname("timeline-content--justify-start")]: justify === "start",
      [prefixClassname("timeline-content--justify-center")]: justify === "center",
      [prefixClassname("timeline-content--justify-end")]: justify === "end",
      [prefixClassname("timeline-content--justify-space-around")]: justify === "space-around",
      [prefixClassname("timeline-content--justify-space-between")]: justify === "space-between",
      [prefixClassname("timeline-content--align-start")]: align === "start",
      [prefixClassname("timeline-content--align-center")]: align === "center",
      [prefixClassname("timeline-content--align-end")]: align === "end",
      [prefixClassname("timeline-content--align-baseline")]: align === "baseline",
      [prefixClassname("timeline-content--align-stretch")]: align === "stretch"
    }, className)
  }, restProps));
}

export default TimeLineContent;
//# sourceMappingURL=timeline-content.js.map
