import _isPlainObject from "lodash/isPlainObject";
import _assign from "lodash/assign";
var _excluded = ["selector"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { Events } from "@tarojs/taro";
import { isValidElement, useEffect } from "react";
var initialToastOptions = {
  className: undefined,
  style: undefined,
  backdrop: undefined,
  type: undefined,
  position: undefined,
  icon: undefined,
  duration: undefined,
  message: undefined
};
var DEFAULT_TOAST_SELECTOR = "#toast";
var defaultToastOptions = {};
resetDefaultToastOptions();
export function setDefaultToastOptions(options) {
  _assign(defaultToastOptions, options);
}
export function resetDefaultToastOptions() {
  _assign(defaultToastOptions, {
    selector: DEFAULT_TOAST_SELECTOR
  });
}
var toastEvents = new Events();
export function useToastOpen(cb) {
  useEffect(() => {
    toastEvents.on("open", cb);
    return () => {
      toastEvents.off("open", cb);
    };
  }, []);
}
export function useToastClose(cb) {
  useEffect(() => {
    toastEvents.on("close", cb);
    return () => {
      toastEvents.off("close", cb);
    };
  }, []);
}

function parseToastOptions(message) {
  var options = ! /*#__PURE__*/isValidElement(message) && _isPlainObject(message) ? message : {
    message
  };
  return _assign({}, initialToastOptions, defaultToastOptions, options);
}

export function openToast(args) {
  var _parseToastOptions = parseToastOptions(args),
      {
    selector
  } = _parseToastOptions,
      restOptions = _objectWithoutProperties(_parseToastOptions, _excluded);

  toastEvents.trigger("open", _objectSpread({
    selector
  }, restOptions));
}
export function createToast(type) {
  return args => {
    var options = parseToastOptions(args);
    options.type = type;
    openToast(options);
  };
}
export function closeToast(selector) {
  toastEvents.trigger("close", selector !== null && selector !== void 0 ? selector : defaultToastOptions.selector);
}
//# sourceMappingURL=toast.imperative.js.map
