var _excluded = ["id", "className", "defaultOpen", "open", "icon", "type", "position", "duration", "children", "backdrop", "onClose"],
    _excluded2 = ["selector", "message"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { useUncontrolled } from "@nickeylin/taroify-hooks";
import { Fail, Success } from "@nickeylin/taroify-icons";
import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { Children, cloneElement, isValidElement, useEffect, useMemo } from "react";
import Backdrop from "../backdrop";
import { useTimeout } from "../hooks";
import Loading from "../loading";
import Popup, { usePopupBackdrop } from "../popup";
import { prefixClassname } from "../styles";
import { getElementSelector, matchSelector, prependPageSelector, usePrependPageSelector } from "../utils/dom/element";
import { useObject, useToRef } from "../utils/state";
import { isElementOf } from "../utils/validate";
import { useToastClose, useToastOpen } from "./toast.imperative";
var TOAST_PRESET_TYPES = ["text", "loading", "success", "fail", "html"];
var TOAST_PRESET_POSITIONS = ["top", "middle", "bottom"];

function defaultToastIcon(icon, type) {
  if (icon) {
    return icon;
  }

  if (type === "success") {
    return /*#__PURE__*/React.createElement(Success, null);
  }

  if (type === "loading") {
    return /*#__PURE__*/React.createElement(Loading, {
      className: prefixClassname("toast__loading")
    });
  }

  if (type === "fail") {
    return /*#__PURE__*/React.createElement(Fail, null);
  }

  return undefined;
}

function useToastIcon(node, type) {
  return useMemo(() => {
    var icon = defaultToastIcon(node, type);

    if (! /*#__PURE__*/isValidElement(icon)) {
      return icon;
    }

    var element = icon;
    return /*#__PURE__*/cloneElement(icon, {
      className: classNames(prefixClassname("toast__icon"), element.props.className)
    });
  }, [node, type]);
}

function useToastChildren(children) {
  return useMemo(() => {
    var __children__ = {
      content: []
    };
    Children.forEach(children, child => {
      if ( /*#__PURE__*/isValidElement(child)) {
        var element = child;

        if (isElementOf(element, Backdrop)) {
          __children__.backdrop = element;
        } else {
          var _children__$content;

          (_children__$content = __children__.content) === null || _children__$content === void 0 ? void 0 : _children__$content.push(child);
        }
      } else {
        var _children__$content2;

        (_children__$content2 = __children__.content) === null || _children__$content2 === void 0 ? void 0 : _children__$content2.push(child);
      }
    });

    if (!__children__.backdrop) {
      __children__.backdrop = /*#__PURE__*/React.createElement(Popup.Backdrop, {
        open: false
      });
    }

    return __children__;
  }, [children]);
}

export default function Toast(props) {
  var _useObject = useObject(props),
      {
    object: {
      id,
      className,
      defaultOpen,
      open: openProp,
      icon: iconProp,
      type = "text",
      position = "middle",
      duration = 3000,
      children: childrenProp,
      backdrop: backdropOptions,
      onClose
    },
    setObject
  } = _useObject,
      restProps = _objectWithoutProperties(_useObject.object, _excluded);

  var rootSelectorRef = useToRef(usePrependPageSelector(getElementSelector(id)));
  var {
    value: open = false,
    setValue: setOpen
  } = useUncontrolled({
    defaultValue: defaultOpen,
    value: openProp,
    onChange: aOpened => !aOpened && (onClose === null || onClose === void 0 ? void 0 : onClose(aOpened))
  });
  var {
    backdrop: backdropElement,
    content
  } = useToastChildren(childrenProp);
  var backdrop = usePopupBackdrop(backdropElement, backdropOptions);
  var icon = useToastIcon(iconProp, type);
  var {
    stop: stopAutoClose,
    restart: restartAutoClose
  } = useTimeout();
  useEffect(() => {
    if (open) {
      restartAutoClose(() => {
        setOpen(false);
        stopAutoClose();
      }, duration);
    } else {
      stopAutoClose();
    }

    return () => stopAutoClose();
  }, [duration, open, restartAutoClose, setObject, setOpen, stopAutoClose]);
  useToastOpen(_ref => {
    var {
      selector,
      message
    } = _ref,
        restOptions = _objectWithoutProperties(_ref, _excluded2);

    if (matchSelector(prependPageSelector(selector), rootSelectorRef.current)) {
      restartAutoClose();
      setObject(_objectSpread({
        children: message
      }, restOptions));
      setOpen(true);
    }
  });
  useToastClose(selector => {
    if (matchSelector(prependPageSelector(selector), rootSelectorRef.current)) {
      setOpen(false);
    }
  });
  return /*#__PURE__*/React.createElement(Popup, _objectSpread({
    open: open,
    id: id,
    className: classNames(prefixClassname("toast"), {
      [prefixClassname("toast--".concat(position))]: TOAST_PRESET_POSITIONS.includes(position),
      [prefixClassname("toast--".concat(type))]: !icon && TOAST_PRESET_TYPES.includes(type)
    }, className)
  }, restProps), backdrop, icon, icon ? /*#__PURE__*/React.createElement(View, {
    className: prefixClassname("toast__message"),
    children: content
  }) : content);
}
//# sourceMappingURL=toast.js.map
