import { ReactNode } from "react";
import { EnterHandler, ExitHandler } from "react-transition-group/Transition";
export declare enum TransitionName {
    Fade = "fade",
    SlideUp = "slide-up",
    SlideDown = "slide-down",
    SlideLeft = "slide-left",
    SlideRight = "slide-right"
}
interface TransitionProps {
    name?: TransitionName | string;
    in?: boolean;
    appear?: boolean;
    mountOnEnter?: boolean;
    unmountOnExit?: boolean;
    timeout?: number | {
        appear?: number;
        enter?: number;
        exit?: number;
    };
    children?: ReactNode;
    onEnter?: EnterHandler<HTMLElement>;
    onEntering?: EnterHandler<HTMLElement>;
    onEntered?: EnterHandler<HTMLElement>;
    onExit?: ExitHandler<HTMLElement>;
    onExiting?: ExitHandler<HTMLElement>;
    onExited?: ExitHandler<HTMLElement>;
}
export default function Transition(props: TransitionProps): JSX.Element;
export {};
