import _isArray from "lodash/isArray";
var _excluded = ["value", "children"],
    _excluded2 = ["className", "defaultTabValue", "tabValue", "defaultValue", "value", "activeIcon", "children", "onTabChange", "onChange"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { useUncontrolled } from "@nickeylin/taroify-hooks";
import { Success } from "@nickeylin/taroify-icons";
import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { Children, cloneElement, isValidElement, useCallback } from "react";
import Sidebar from "../sidebar";
import { prefixClassname } from "../styles";
import TreeSelectOption from "./tree-select-option";
import TreeSelectTab from "./tree-select-tab";
import TreeSelectContext from "./tree-select.context";

function getTreeSelectOptions(children) {
  var options = [];
  Children.forEach(children, (child, index) => {
    if (! /*#__PURE__*/isValidElement(child)) {
      return;
    }

    var element = child;
    var elementType = element.type;

    if (elementType === TreeSelectOption) {
      var {
        key
      } = element;
      options.push( /*#__PURE__*/cloneElement(element, {
        key: key !== null && key !== void 0 ? key : index,
        __dataKey__: key !== null && key !== void 0 ? key : index,
        __dataIndex__: index
      }));
    } else {
      options.push(element);
    }
  });
  return options;
}

function useTreeSelectChildren(children, tabValue) {
  var __children__ = {
    tabs: [],
    options: []
  };
  Children.forEach(children, (child, index) => {
    if (! /*#__PURE__*/isValidElement(child)) {
      return;
    }

    var element = child;
    var elementType = element.type;

    if (elementType === TreeSelectTab) {
      var {
        key,
        props
      } = element;

      var {
        value: oldValue,
        children: childrenProp
      } = props,
          restProps = _objectWithoutProperties(props, _excluded);

      var value = oldValue !== null && oldValue !== void 0 ? oldValue : index;

      __children__.tabs.push( /*#__PURE__*/cloneElement(element, _objectSpread({
        key: key !== null && key !== void 0 ? key : value,
        value: value,
        children: childrenProp
      }, restProps)));

      if (tabValue === value) {
        __children__.options.push(...getTreeSelectOptions(childrenProp));
      }
    }
  });
  return __children__;
}

function TreeSelect(props) {
  var {
    className,
    defaultTabValue,
    tabValue: tabValueProp,
    defaultValue,
    value: valueProp,
    activeIcon = /*#__PURE__*/React.createElement(Success, null),
    children: childrenProp,
    onTabChange: onTabChangeProp,
    onChange: onChangeProp
  } = props,
      restProps = _objectWithoutProperties(props, _excluded2);

  var {
    value: tabValue = 0,
    setValue: setTabValue
  } = useUncontrolled({
    value: tabValueProp,
    defaultValue: defaultTabValue,
    onChange: onTabChangeProp
  });
  var {
    value = 0,
    setValue
  } = useUncontrolled({
    value: valueProp,
    defaultValue,
    onChange: onChangeProp
  });
  var {
    tabs,
    options
  } = useTreeSelectChildren(childrenProp, tabValue);
  var onOptionClick = useCallback(_ref => {
    var {
      disabled,
      active,
      value: evtValue
    } = _ref;

    if (disabled) {
      return;
    }

    var multiselect = _isArray(value);

    if (multiselect) {
      if (active) {
        setValue(value.concat(evtValue));
      } else {
        setValue(value.filter(aValue => aValue !== evtValue));
      }
    } else {
      setValue(value === evtValue && !active ? undefined : evtValue);
    }
  }, [value, setValue]);
  return /*#__PURE__*/React.createElement(TreeSelectContext.Provider, {
    value: {
      activeIcon,
      value,
      onOptionClick
    }
  }, /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("tree-select"), className)
  }, restProps), /*#__PURE__*/React.createElement(Sidebar, {
    className: prefixClassname("tree-select__sidebar"),
    defaultValue: defaultTabValue,
    value: tabValue,
    onChange: newTab => setTabValue(newTab),
    children: tabs
  }), /*#__PURE__*/React.createElement(View, {
    className: prefixClassname("tree-select__content"),
    children: options
  })));
}

export default TreeSelect;
//# sourceMappingURL=tree-select.js.map
