var _excluded = ["className", "type", "url", "name", "removable", "mode", "alt", "round", "children", "onRemove"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import { Description } from "@nickeylin/taroify-icons";
import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { useContext } from "react";
import Image from "../image";
import { prefixClassname } from "../styles";
import UploaderRemove from "./uploader-remove";
import UploaderContext from "./uploader.context";
import { isImageFile } from "./uploader.utils";

function UploaderImage(props) {
  var {
    className,
    type,
    url,
    name,
    removable: removableProp,
    mode,
    alt,
    round,
    children,
    onRemove
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var {
    removable: ctxRemovable
  } = useContext(UploaderContext);
  var removable = removableProp !== null && removableProp !== void 0 ? removableProp : ctxRemovable;

  function renderFile() {
    if (isImageFile({
      type,
      url
    })) {
      return /*#__PURE__*/React.createElement(Image, {
        className: prefixClassname("uploader__preview-image"),
        src: url,
        mode: mode,
        alt: alt,
        round: round
      });
    }

    return /*#__PURE__*/React.createElement(View, {
      className: prefixClassname("uploader__file")
    }, /*#__PURE__*/React.createElement(Description, {
      className: prefixClassname("uploader__file-icon")
    }), /*#__PURE__*/React.createElement(View, {
      className: classNames(prefixClassname("uploader__file-name"), prefixClassname("ellipsis")),
      children: name !== null && name !== void 0 ? name : url
    }));
  }

  return /*#__PURE__*/React.createElement(View, _objectSpread({
    className: classNames(prefixClassname("uploader__preview"), className)
  }, restProps), renderFile(), children, removable && /*#__PURE__*/React.createElement(UploaderRemove, {
    onClick: onRemove
  }));
}

export default UploaderImage;
//# sourceMappingURL=uploader-image.js.map
