import _map2 from "lodash/map";
import _isArray from "lodash/isArray";
import _forEach2 from "lodash/forEach";
import _first from "lodash/first";
import { Children as ReactChildren } from "react";
import { isObjectElement } from "./validate";

function isObjectChildren(children) {
  if (!_isArray(children)) {
    return false;
  }

  var node = _first(children);

  return isObjectElement(node);
}

function forEachChildren(children, fn) {
  var objectified = isObjectChildren(children);
  var forEach = objectified ? _forEach2 : ReactChildren.forEach;
  return forEach(children, fn);
}

function mapChildren(children, fn) {
  var objectified = isObjectChildren(children);
  var map = objectified ? _map2 : ReactChildren.map;
  return map(children, fn);
}

var Children = {
  toArray: ReactChildren.toArray,
  forEach: forEachChildren,
  map: mapChildren
};
export default Children;
//# sourceMappingURL=children.js.map
