import { useCallback, useMemo } from "react";

class GetterRef {
  constructor(getter) {
    this.getter = getter;
  }

  get value() {
    return this.getter();
  }

}

export function useComputed(getter) {
  var deps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

  var __getter__ = useCallback(getter, [getter, ...deps]);

  return useMemo(() => {
    return new GetterRef(__getter__);
  }, [__getter__]);
}
//# sourceMappingURL=computed.js.map
