import { createElement, isValidElement } from "react";
import { isObjectElement, isTextElement } from "./validate";

function createVariantComponentWrapper(children, displayName) {
  var Component = () => children;

  Component.displayName = displayName;
  return Component;
}

export function createVariantElement(type, node) {
  if (isTextElement(node)) {
    return /*#__PURE__*/createElement(type, {
      children: node
    });
  }

  if (isObjectElement(node)) {
    return /*#__PURE__*/createElement(type, node);
  }

  if ( /*#__PURE__*/isValidElement(node)) {
    var ComponentWrapper = createVariantComponentWrapper(node, type.displayName);
    return /*#__PURE__*/createElement(ComponentWrapper);
  }

  return node;
}
//# sourceMappingURL=element.js.map
