import { ITouchEvent } from "@tarojs/components";
export declare enum TouchDirection {
    Horizontal = "horizontal",
    Vertical = "vertical"
}
export interface TouchRef {
    startX: number;
    startY: number;
    deltaX: number;
    deltaY: number;
    offsetX: number;
    offsetY: number;
    direction?: TouchDirection;
    isVertical(): boolean;
    isHorizontal(): boolean;
    start(event: ITouchEvent): void;
    move(event: ITouchEvent): void;
    reset(): void;
}
export declare function useTouch(): TouchRef;
