import { View } from "@tarojs/components";
import classNames from "classnames";
import * as React from "react";
import { useMemo } from "react";
import { prefixClassname } from "../styles";
export var WhiteSpaceSize;

(function (WhiteSpaceSize) {
  WhiteSpaceSize["Mini"] = "mini";
  WhiteSpaceSize["Small"] = "small";
  WhiteSpaceSize["Medium"] = "medium";
  WhiteSpaceSize["Large"] = "large";
})(WhiteSpaceSize || (WhiteSpaceSize = {}));

var SIZE_PRESETS = [WhiteSpaceSize.Mini, WhiteSpaceSize.Small, WhiteSpaceSize.Medium, WhiteSpaceSize.Large];

function isPresetSize(size) {
  return SIZE_PRESETS.includes(size);
}

export default function WhiteSpace(props) {
  var {
    size = WhiteSpaceSize.Medium
  } = props;
  var rootStyle = useMemo(() => ({
    height: isPresetSize(size) ? "" : size
  }), [size]);
  return /*#__PURE__*/React.createElement(View, {
    className: classNames(prefixClassname("white-space"), {
      [prefixClassname("white-space-size-".concat(size))]: isPresetSize(size)
    }),
    style: rootStyle
  });
}
//# sourceMappingURL=white-space.js.map
